#ifndef	MVLIB_H
#define	MVLIB_H

typedef	double	vec_t;
typedef	vec_t	vec3_t[3];
#define	MAXVEC	(1E+38)

#define	vec3Zero(dst) \
{ \
	(dst)[0] = 0; \
	(dst)[1] = 0; \
	(dst)[2] = 0; \
}

#define	vec3Set(dst, x, y, z) \
{ \
	(dst)[0] = x; \
	(dst)[1] = y; \
	(dst)[2] = z; \
}

#define	vec3Copy(dst, src) \
{ \
	(dst)[0] = (src)[0]; \
	(dst)[1] = (src)[1]; \
	(dst)[2] = (src)[2]; \
}

#define	vec3Add(dst, v1, v2) \
{ \
	(dst)[0] = (v1)[0] + (v2)[0]; \
	(dst)[1] = (v1)[1] + (v2)[1]; \
	(dst)[2] = (v1)[2] + (v2)[2]; \
}

#define	vec3Sub(dst, v1, v2) \
{ \
	(dst)[0] = (v1)[0] - (v2)[0]; \
	(dst)[1] = (v1)[1] - (v2)[1]; \
	(dst)[2] = (v1)[2] - (v2)[2]; \
}

#define	vec3Scale(dst, v, scale) \
{ \
	vec_t local_scale = (vec_t)(scale); \
	(dst)[0] = (v)[0] * local_scale; \
	(dst)[1] = (v)[1] * local_scale; \
	(dst)[2] = (v)[2] * local_scale; \
}

#define	vec3Dot(v1, v2) \
	((v1)[0] * (v2)[0] + (v1)[1] * (v2)[1] + (v1)[2] * (v2)[2])

#define	vec3Abs(v) \
	((vec_t)sqrt(vec3Dot(v,v)))

#define	bboxClear(mins,maxs) \
{ \
	vec3Set(mins,MAXVEC,MAXVEC,MAXVEC); \
	vec3Set(maxs,-MAXVEC,-MAXVEC,-MAXVEC); \
}

#define	bboxAddPoint(mins,maxs,p) \
{ \
	if((mins)[0] > (p)[0]) (mins)[0] = (p)[0]; \
	if((maxs)[0] < (p)[0]) (maxs)[0] = (p)[0]; \
	if((mins)[1] > (p)[1]) (mins)[1] = (p)[1]; \
	if((maxs)[1] < (p)[1]) (maxs)[1] = (p)[1]; \
	if((mins)[2] > (p)[2]) (mins)[2] = (p)[2]; \
	if((maxs)[2] < (p)[2]) (maxs)[2] = (p)[2]; \
}

#endif	/* !MVLIB_H */
